          section   TEXT

          xdef      _fi2_parm
          xref      __usefi2
          xref      __freefi2

* Prototype: int fi2_parm(void * act_array, int param_code, int act_idx, \
*                         short * act_type, unsigned short * act_flags, \
*                         char * act_param);

_fi2_parm MOVEM.L   D3/A2/A4,-(SP)                Save the context.
          MOVE.L    #'PARM',D2                    Extension to be used.
          JSR       __usefi2                      Use it.
          BNE.S     FI2PARM1                      If error, return now.
          LEA       16(SP),A0                     Pointer on first parameter.
          MOVEA.L   (A0)+,A1                      Pointer on the array.
          MOVE.L    (A0)+,D1                      Code for requested parameter.
          MOVE.L    (A0)+,D2                      Index of considered action.
          JSR       (A4)                          Call the extension.
          BNE.S     FI2PARM2                      If error, return now.
          MOVEA.L   4(A0),A4                      Pointer on act_flags variable.
          MOVE.W    D3,(A4)                       Store the action flags.
          SWAP      D3                            Action type in LSW.
          MOVEA.L   (A0),A4                       Pointer on act_type variable.
          MOVE.W    D3,(A4)                       Store the action type.
          MOVEA.L   8(A0),A4                      Pointer on "act_param" string.
          MOVE.W    (A2)+,D1                      Chars number of parameter.
          BRA.S     FI2PARM3                      Start to transfer characters.
FI2PARM4  MOVE.B    (A2)+,(A4)+                   Copy on character.
FI2PARM3  DBRA      D1,FI2PARM4                   And repeat for all characters.
          CLR.B     (A4)                          Put the ending 0.
FI2PARM2  JSR       __freefi2                     Free the extension thing.
FI2PARM1  MOVEM.L   (SP)+,D3/A2/A4                Restore the context.
          RTS                                     Return to calling function.

          end
