30000 REMark copyright (c) W. Lenerz 2000
30010 REMark parts of the code Copyright (c) Thierry Godefroy 2000
30020 REMark *******************************************************************
30030 REMark  call as follows:
30040 REMark *******************************************************************
30050 :
30060 DEFine FuNction read_and_install_extensions
30070 REMark this presumes that you get the DATAs right:
30080 REMark number of extension/action blocks (starting at 1)
30090 REMark then, for each such block there must be one of each:
30100 REMark extension$, type,flag(s),name$,job$,thing$,file$,command$
30110 REMark (for explanaion of these, see the FileInfo manual)
30120 REMark you can use empty strings ('') if need be
30130 REMark if you pass an empty string for the extension name, then an action
30140 REMark block is created for the previous extension
30150 LOCal loop,count,fi_ext$(0),fi_type(0),fi_flags(0),fi_name$(0)
30160 LOCal fi_job$(0),fi_thing$(0),fi_file$(0),fi_command$(0)
30170   RESTORE
30180   IF EOF:RETurn -15                     : REMark OOOPS, no data?
30190   READ count                            : REMark how many blocks?
30200   IF NOT count:RETurn -15               : REMark none!
30210   DIM fi_ext$(count,4)                  : REMark there are some, make some arrays
30220   DIM fi_type(count)
30230   DIM fi_flags(count)
30240   DIM fi_name$(count,40)
30250   DIM fi_job$ (count,60)
30260   DIM fi_thing$ (count,60)
30270   DIM fi_file$(count,44)
30280   DIM fi_command$ (count,120)
30290   FOR loop = 1 TO count
30300     READ fi_ext$(loop)                  : REMark read the arrays
30310     READ fi_type(loop)
30320     READ fi_flags(loop)
30330     READ fi_name$(loop)
30340     READ fi_job$ (loop)
30350     READ fi_thing$ (loop)
30360     READ fi_file$(loop)
30370     READ fi_command$ (loop)
30380   END FOR loop
30390   RETurn install_extension_in_fileinfo2 (fi_ext$,fi_type,fi_flags,fi_name$,fi_job$,fi_thing$,fi_file$,fi_command$)
30400 END DEFine read_and_install_extensions
30410 :
30420 DEFine FuNction install_extension_in_fileinfo2 (fi_ext$,fi_type,fi_flags,fi_name$,fi_job$,fi_thing$,fi_file$,fi_command$)
30430 LOCal finfo%,fi2file$,fi_mainloop,ext_to_install$,next_ext%,all_exts$,count%,old_ext$
30440 LOCal fi_chan%
30450   fi_chan%=1
30460   count%=DIMN(fi_ext$,1)                   : REMark how many extensions?
30470   IF count%<>DIMN(fi_type,1):PRINT "ret":RETurn -15 : REMark check that all parameters are the same!
30480   IF count%<>DIMN(fi_flags,1):RETurn -15
30490   IF count%<>DIMN(fi_name$,1):RETurn -15
30500   IF count%<>DIMN(fi_job$,1) :RETurn -15
30510   IF count%<>DIMN(fi_thing$,1):RETurn -15
30520   IF count%<>DIMN(fi_file$,1):RETurn -15
30530   IF count%<>DIMN(fi_command$,1):RETurn -15
30540   fi2file$=""                           : REMark to contain name of the Finfo file
30550   old_ext$=""                           : REMark old extension if second action block
30560   init_install_extensions_window        : REMark do some initialisation
30570   fi_set_texts                          : REMark language dependent texts
30580   IF fileinfo_absent%:RETurn -19        : REMark check whether FileInfo 2 is present, and what version
30590   FOR fi_mainloop =1 TO count%
30600     ext_to_install$=fi_ext$(fi_mainloop): REMark extension to install
30610     IF ext_to_install$=""
30620                                         : REMark no extension name -just create ...
30630                                         : REMark ...action block for previous extn
30640        IF old_ext$=""
30650          NEXT fi_mainloop               : REMark OOPs, no previous extension !
30660          EXIT fi_mainloop               : REMark prevent fall through if last iteration
30670        ELSE
30680          what_type=2                    : REMark show create action block
30690        END IF
30700     ELSE
30710       old_ext$=ext_to_install$          : REMark several action blocks for one extn
30720       what_type=check_extension% (ext_to_install$)
30730     END IF
30740     SELect ON what_type
30750       =0 :                              : REMark don't install (you can delete this line)
30760       =1 : install_this_extension fi_mainloop, "": REMark create extn block
30770       =2 : install_this_extension fi_mainloop,old_ext$: REMark create action block
30780     END SELect
30790   END FOR fi_mainloop
30800   RETurn write_fileinfo_file (fi2file$) : REMark write file now
30810 END DEFine install_extension_in_fileinfo2
30820 :
30830 DEFine PROCedure init_install_extensions_window
30840 REMark open window, set texts and some variables
30850   fi_chan%=1
30860   WINDOW#fi_chan%,320,22,50,50
30870   INK#fi_chan%,0
30880   PAPER#fi_chan%,7
30890   CSIZE 2,1
30900   CLS#fi_chan%
30910   AT 0,5:PRINT "FileInfo Installer"
30920   WINDOW#fi_chan%,320,80,50,74
30930   BORDER#fi_chan%,1,7
30940   INK#fi_chan%,7
30950   PAPER#fi_chan%,0
30960   CLS#fi_chan%
30970   CSIZE#fi_chan%,0,0
30980 END DEFine init_install_extensions_window
30990 :
31000 DEFine PROCedure fi_set_texts
31010 REMark set up language dependent texts
31020   DIM fi2text$(20,50)
31030   fi2text$(1) ="Is FileInfo II v. 3.xx loaded? (y/n)"
31040   fi2text$(2) ="yn"
31050   fi2text$(3) ="If you have FileInfo II v. 3.xx loaded,"
31060   fi2text$(4) ="then  you  can  install the  extensions"
31070   fi2text$(5) ="for this program automatically."
31080   fi2text$(6) ="Do you want to do this? (y/n)"
31090   fi2text$(7) ="A program is already using this extension!"
31100   fi2text$(8) ="Add this program to this extension (y/n)?"
31110   fi2text$(9) ="Making block for extension: "
31120   fi2text$(10)="Couldn't make this block!"
31130   fi2text$(11)="Please hit a key"
31140   fi2text$(12)="Please enter the complete filename"
31150   fi2text$(13)="for the new fileinfo file"
31160   fi2text$(14)="File already exists - Overwrite (y/n)?"
31170   fi2text$(15)="Saving file: "
31180   fi2text$(16)="The length of your FileInfo file, "
31190   fi2text$(17)="may have changed!"
31200   fi2text$(18)="Please remember this when loading it!"
31210 END DEFine mytexts
31220 :
31230 DEFine FuNction fileinfo_absent%
31240 LOCal lp,a$
31250 REMark checks whether FileInfo is loaded
31260 REMark and whether a filename is present
31270 REMark this also sets fi2file$, ifpossible
31280 REMark returns 1 - no finfo loaded
31290 REMark         0 - fileinfo loaded
31300   CLS#fi_chan%
31310   FOR lp=3 TO 5 :PRINT#fi_chan%,fi2text$(lp)
31320   PRINT#fi_chan%
31330   a$=fi_get_reply$ (fi2text$(6))
31340   IF a$==fi2text$(2,2):RETurn 1         : REMark don't want to insert automatically
31350   CLS#fi_chan%
31360   PAUSE#fi_chan%, 10
31370   a$=fi_get_reply$(fi2text$(1))
31380   IF a$==fi2text$(2,2):RETurn 1         : REMark no FileInfo loaded!
31390   a$=FI2_INFO$(0)                       : REMark get info on fileinfo
31400   IF a$<"3.50":RETurn 0                 : REMark old version
31410   fi2file$=FI2_SCAN$(1,FI2_INFO$(2),1)  : REMark try to set this file
31420   RETurn 0
31430 END DEFine fileinfo_absent%
31440 :
31450 DEFine FuNction fi_get_reply$ (fi_prompt$)
31460 REMark get yes/no keystroke, don't allow any other
31470 LOCal lp,a$
31480   PRINT#fi_chan%,fi_prompt$
31490   REPeat lp
31500     a$=INKEY$(#fi_chan%,-1)             : REMark get reply
31510     IF a$ INSTR fi2text$(2):EXIT lp     : reply ok
31520   END REPeat lp
31530   RETurn a$
31540 END DEFine fi_get_reply$
31550 :
31560 DEFine FuNction check_extension% (ext_to_install$)
31570 REMark checks whether this extension already exists
31580 REMark if yes, asks user if this is to be added anyway
31590 REMark returns: 0 if user doesn't want to install this extension
31600 REMark          1 if extension doesn't exist yet
31610 REMark          2 if extension exists, but user wants to add this action
31620 LOCal c_ext$,CheckExt
31630   c_ext$=FI2_NEXT$(FI2_INFO$(2))        : REMark init for loop
31640   REPeat CheckExt
31650    IF c_ext$="" OR c_ext$==ext_to_install$: EXIT CheckExt
31660    c_ext$=FI2_NEXT$(c_ext$)
31670   END REPeat CheckExt
31680   IF c_ext$=""
31690     RETurn 1                            : REMark extn doesn't exist, add
31700   ELSE
31710     CLS#fi_chan%                        : REMark extn exists, do we add prog to it?
31720     PRINT#fi_chan%\fi2text$(7)\ext_to_install$
31730     IF fi_get_reply$(fi2text$(8))==fi2text$(2,2): RETurn 0 : REMark user doesn't want to add
31740   END IF
31750   RETurn 2                              : REMark exists, but add
31760 END DEFine check_extension%
31770 :
31780 DEFine PROCedure install_this_extension (count,old_ext$)
31790 REMark this makes the extension/action block and links it into FIleInfo
31800 LOCal address,a$, error_code
31810   CLS#fi_chan%
31820   PRINT#fi_chan%\\fi2text$(9);          : REMark keep user informed
31830   IF old_ext$<>""
31840     PRINT#fi_chan%,old_ext$
31850     address=FI2_MAKE('FIv3',fi_type(count),fi_flags(count),fi_name$(count),fi_job$(count),fi_thing$(count),fi_file$(count),fi_command$(count))
31860     IF address<0
31870       error_code=address                : REMark ooops
31880     ELSE
31890       error_code=FI2_LINK(old_ext$,address): REMark link in action block
31900     END IF
31910   ELSE
31920     PRINT#fi_chan%,fi_ext$(count)
31930     address=FI2_MAKE('FIv3',fi_ext$(count),fi_type(count),fi_flags(count),fi_name$(count),fi_job$(count),fi_thing$(count),fi_file$(count),fi_command$(count))
31940     IF address<0
31950       error_code=address
31960     ELSE
31970       error_code=FI2_LINK(address)      : REMark link in extension block
31980     END IF
31990   END IF
32000   IF error_code<0
32010     PRINT#fi_chan%,fi2text$(10)\fi2text$(11)
32020     a$=INKEY$(#fi_chan%,-1)             : REMark oops, error!
32030     RETurn
32040   END IF
32050 END DEFine install_this_extension
32060 :
32070 DEFine FuNction write_fileinfo_file (fi2file$)
32080 REMark this saves the file
32090 REMark returns 0 if OK, else error
32100 LOCal save_chan%
32110   IF fi2file$=""
32120     CLS#fi_chan%
32130     PRINT#fi_chan%,fi2text$(12)\fi2text$(13)
32140     INPUT#fi_chan%,fi2file$
32150   END IF
32160   IF fi2file$="":RETurn 0               : REMark empty here, so user doesn't want to save
32170   save_chan%=FTEST (fi2file$)           : REMark uses TK II
32180   IF NOT save_chan%
32190     CLS#fi_chan%
32200     PRINT#fi_chan%,fi2file$;" : "
32210     a$=fi_get_reply$(fi2text$(14))
32220     IF a$==fitext$(2,2): RETurn 0       : REMark user doesn't want to save, no error
32230   END IF
32240   CLS#fi_chan%
32250   PRINT fi_chan%,fi2text$(15)\fi2file$
32260   save_chan%=FOP_OVER(fi2file$)         : REMark uses TK II
32270   IF save_chan%<0:RETurn save_chan%     : REMark ooops!
32280   FI2_SAVE#save_chan%,0                 : REMark write it now
32290   CLOSE #save_chan%
32300   CLS#fi_chan%
32310   PRINT#fi_chan%,fi2text$(16)\fi2file$
32320   PRINT#fi_chan%,fi2text$(17)\fi2text$(18)
32330   RETurn 0                              : REMark ok
32340 END DEFine write_fileinfo_file
32350 :
32360 DATA 2
32370 DATA 'test',1,0,'Execute Test-> QD?',"","QD","DEV1_BOOTY_QD",'\F '
32380 DATA '',1,0,'Execute Test2-> QD?',"","QD","DEV1_BOOTY_QD",'\F '
32390 :
32400 DEFine PROCedure test
32405 LOCal fitest
32410  fitest= read_and_install_extensions
32420 END DEFine test
32430 :
