          section   TEXT

          xdef      _fi2_thrd
          xref      __usefi2
          xref      __freefi2
          xref      __c2qdos
          xref      __freestr

* Prototype: int fi2_thrd(chanid_t con_id, timeout_t delay, int priority, \
*                         char * command_string);

_fi2_thrd MOVEM.L   D3/A2/A4,-(SP)                Save the context.
          MOVE.L    #'THRD',D2                    Extension to be used.
          JSR       __usefi2                      Use it.
          BNE.S     FI2THRD1                      If error, return.
          LEA       16(SP),A2                     Pointer on first parameter.
          MOVEA.L   10(A2),A1                     Pointer on C string.
          JSR       __c2qdos                      Convert it to a QDOS string.
          BNE.S     FI2THRD2                      If error, return.
          MOVE.L    (A2)+,D1                      Console channel Id.
          MOVE.W    (A2)+,D3                      Timeout.
          MOVE.L    (A2),D2                       Priority.
          JSR       (A4)                          Call the extension.
          JSR       __freestr                     Free the string heap space.
FI2THRD2  JSR       __freefi2                     Free the extension thing.
FI2THRD1  MOVEM.L   (SP)+,D3/A2/A4                Restore the context.
          RTS                                     Return to calling function.

          end
